<?php
namespace FiloBlu\ExtMysqlSearch\Model\Config;
use Magento\Catalog\Model\ResourceModel\Product\Attribute\CollectionFactory;

class SelectAttribute implements \Magento\Framework\Option\ArrayInterface
{
    /**
     * @var CollectionFactory
     */
    private $collectionFactory;

    /**
     * SelectAttribute constructor.
     * @param CollectionFactory $collectionFactory
     */
    public function __construct(CollectionFactory $collectionFactory){

        $this->collectionFactory = $collectionFactory;
    }


    /**
     * @return array
     */
    private function getAllProductAttributes(){
        $attributes = $this->collectionFactory->create()->addFieldToFilter('is_visible_on_front',["eq"=>1])
            ->addFieldToFilter('used_for_sort_by',['eq'=>1])->getItems();
        $arr =[];
        $arr [] = ['value' => -1, 'label' => __('Select An Attribute')];
        if($attributes){
            foreach ($attributes as $val){
                $arr [] = ['value'=>$val->getData('attribute_code'),'label'=>__($val->getData('frontend_label'))];
            }
        }
        return $arr;

    }


    /**
     * @return array
     */
    public function toOptionArray()
    {
       return $this->getAllProductAttributes();
    }
}